Int_t ped()
{
////////////////////////////////////////
// Rudi Ganz  Pedestal File generation
// Ver 1.0    17. August 1997
// UIC  HI Group      ped.c
////////////////////////////////////////

	gROOT->Reset();
	gSystem->Load("PhTestBeam.dll");
	#include <iostream.h>
	#include <string.h>
    
        Int_t FirstRun = 230 ;
        Int_t LastRun = 232 ;  

// Prepare File Names
        char RunFileHead[80] = "i://RUN";
        char PedFileHead[60]="e://Analysis//Pedestal//" ;
        char GeomFileHead[80]="e://Analysis//Geom//";  

	char FileID[6]="00000"; 
        char runfile[81] ="RUN00000.dat" ;
 
        char RunFileTrail[8]=".dat"; 
        char PedFileTrail[8] =".ped";

 	char pedwa98[81] = "dummyPedWA98";
	char pedtele[81] = "dummyPedTele";
	char pedphob[81] = "dummyPedPhob";

        char GeomPhob[81] ="Phobgeom.dat";
        char Geom_Phob[81] ="PhobTranslat.dat";
        char GeomWA98[81] ="WA98geom.dat";
        char Geom_WA98[81] ="WA98radii.dat";
        char GeomTele[81] ="Telegeom.dat";

        sprintf(GeomPhob,"%s%s",GeomFileHead,GeomPhob);
        sprintf(Geom_Phob,"%s%s",GeomFileHead,Geom_Phob);
        sprintf(GeomWA98,"%s%s",GeomFileHead,GeomWA98);       
        sprintf(Geom_WA98,"%s%s",GeomFileHead,Geom_WA98);   
        sprintf(GeomTele,"%s%s",GeomFileHead,GeomTele);

	char * nmwa98 = "WA98";
        char * nmtele = "Tele";
        char * nmphob = "Phob";
	TPhEvent * event = new TPhEvent();

          
// Setup Phob

	TPhPhobFamily * phob = new TPhPhobFamily();
	event->AddFamily(phob);
	phob->ReadGeometry(GeomPhob,Geom_Phob);

// Setup Tele
        TPhTeleFamily * tele = new TPhTeleFamily();
	event->AddFamily(tele);
	tele->ReadGeometry(GeomTele);

// Setup WA98
	TPhWA98Family * wa98 = new TPhWA98Family();
	event->AddFamily(wa98);
	wa98->ReadGeometry(GeomWA98,Geom_WA98);

// Setup All Detectors
	Int_t i;

        Int_t nphob = phob->GetNDetectors();
	TPhDetector * dphob[nphob];
	Int_t sphob[nphob];
	for (i = 0; i < nphob; i++)
	{
	   dphob[i] = phob->GetDetector(i+1);
	   sphob[i] = dphob[i]->GetNChannels();
        }

        Int_t ntele = tele->GetNDetectors();
	TPhDetector * dtele[ntele];
	Int_t stele[ntele];
	for (i = 0; i < ntele; i++)
	{
	   dtele[i] = tele->GetDetector(i+1);
	   stele[i] = dtele[i]->GetNChannels();
        }

        Int_t nwa98 = wa98->GetNDetectors();
	TPhDetector * dwa98[nwa98];
	Int_t swa98[nwa98];
	for (i = 0; i < nwa98; i++)
	{
	   dwa98[i] = wa98->GetDetector(i+1);
	   swa98[i] = dwa98[i]->GetNChannels();
        }

// Check Detectctor Setup:

	cout << endl;

	cout << "Phobos has " << nphob << " Detectors" << endl;
	for (i = 0; i < nphob; i++)
	{
	  cout << "Detector #" << (i+1) << " has " << sphob[i] << " channels.  From " << dphob[i]->GetHitIDMin() << " to " << dphob[i]->GetHitIDMax() << endl;
	}
	cout << endl; 

	cout << "Telescope has " << ntele << " Detectors" << endl;
	for (i = 0; i < ntele; i++)
	{
	  cout << "Detector #" << (i+1) << " has " << stele[i] << " channels.  From " << dtele[i]->GetHitIDMin() << " to " << dtele[i]->GetHitIDMax() << endl;
	}
	cout << endl; 

	cout << "WA98 has " << nwa98 << " Detectors" << endl;
	for (i = 0; i < nwa98; i++)
	{
	  cout << "Detector #" << (i+1) << " has " << swa98[i] << " channels.  From " << dwa98[i]->GetHitIDMin() << " to " << dwa98[i]->GetHitIDMax() << endl;
	}

	cout << endl; 
	


		
// Main Loop

	Int_t ndat = 0;
	Int_t nerr = 0;
	Int_t nped = 0;
	Int_t ncal = 0;
	Int_t test[3];
	Int_t val;
	test[0] = 0;
	test[1] = 0;
	test[2] = 0;
	TPhDetector * det;
        TPhTestData * data = new TPhTestData();

for (Int_t RunNumber=FirstRun ; RunNumber<LastRun+1 ; RunNumber++)
  {
    strcpy(FileID, " ");
                       sprintf(FileID,  "00%d",RunNumber);
    if(RunNumber<100) {sprintf(FileID, "000%d",RunNumber);};
    if(RunNumber<10)  {sprintf(FileID,"0000%d",RunNumber);};

    sprintf(runfile,"%s%s%s",RunFileHead,FileID,RunFileTrail);
    cout << "Now analysing file:"<< runfile <<  endl;
    sprintf(pedwa98,"%sWA98_%s%s",PedFileHead,FileID,PedFileTrail);
    cout << " for pedestal file:"<< pedwa98 <<  endl;
    sprintf(pedtele,"%sTele_%s%s",PedFileHead,FileID,PedFileTrail);
    cout << " for pedestal file:"<< pedtele <<  endl;
    sprintf(pedphob,"%sPhob_%s%s",PedFileHead,FileID,PedFileTrail);
    cout << " for pedestal file:"<< pedphob <<  endl;
  
    data->Open(runfile);

// Read Pedestal Files
	phob->ReadPedFile(pedphob);
        tele->ReadPedFile(pedtele);
	wa98->ReadPedFile(pedwa98);


        if (data->IsOpen())
           {
		 
	   cout << "Data File "<<runfile<<" opened" << endl;
 for (i = 1; !(data->IsEOF()) ; i++)
	   {

// Read Next Event

     	      data->GetNextEvent(event);
	 
// Chose only Data Type
   	      Short_t dtype;
              dtype = event->GetDataType();

	      if (!(i%100) || dtype > 1)
	      {  
//	         cout << "Loop:" << i << " Event:" << event->GetEventNumber() << " Type is " << dtype;
                 if (dtype == 1) 
	         {
//		    cout << " data";
		    ndat++;
	         }
	         else if (dtype == 2)
	         {

// Add new pedestals
//                    cout << " pedestal";
		    nped++;
		    event->AddPed();   
                 }
                 else if (dtype == 3) 
                 {
 //                   cout << " calibration";
		    ncal++;
		
                 }
                 else 
	         {
//                     cout << " error";
		     nerr++;
                 }
//                 cout << endl;
              }
	      else
	      {
		 ndat++;
	      }
	   }
	}
	else
	{
	  cout << "Input File not present" << endl;      
        }

// Write cout event statistics

	cout << "Number of Events      = " << (i-1) << endl;;
	cout << "Number of Data        = " << ndat << endl;
        cout << "Number of Pedestals   = " << nped << endl;
	cout << "Number of Calibration = " << ncal << endl;
        cout << "Number of Errors      = " << nerr << endl;

// Write out Pedestal File

	phob->WritePedFile(pedphob);
	tele->WritePedFile(pedtele);
	wa98->WritePedFile(pedwa98);	

// We Be Done
	cerr << "File is done" << endl;
        data->Close();
  };   // runnumber loop

return 0;
// End of ped.c
} 
